image: docker:latest
services:
  - name: docker:dind
    command: ["--tls=false"]

variables:
  DOCKER_HOST: tcp://docker:2375/
  DJANGO_RELEASE_IMAGE: $CI_REGISTRY_IMAGE/django:$CI_BUILD_REF_NAME
  DJANGO_HOMOLOG_IMAGE: $CI_REGISTRY_IMAGE/django:$CI_BUILD_REF_NAME-$CI_COMMIT_SHORT_SHA
  NGINX_HOMOLOG_IMAGE: $CI_REGISTRY_IMAGE/nginx:$CI_BUILD_REF_NAME-$CI_COMMIT_SHORT_SHA
  NGINX_RELEASE_IMAGE: $CI_REGISTRY_IMAGE/nginx:$CI_BUILD_REF_NAME
  KUBECONFIG: /etc/k8s-config

before_script:
  - echo "$CI_JOB_TOKEN" | docker login -u "gitlab-ci-token" --password-stdin $CI_REGISTRY

stages:
  - build
  - deploy

##########
## Homolog
##########
build to homolog:
  stage: build
  variables:
    DOCKER_DRIVER: overlay2 # Optional, depending on your setup
  script:
    - docker build -f compose/production/Dockerfile --target django -t $DJANGO_HOMOLOG_IMAGE .
    - docker push $DJANGO_HOMOLOG_IMAGE
  only:
    - /develop/
  environment: homolog
  tags:
    - docker

# Add deploy jobs here...
